def getCubicle(branch, startIndex, index):
  if startIndex != index:
    cub = branch.GetCubicle(index)
    if cub != None:
      return [cub]
  return []

def getNextCubs(cub):
  branch = cub.obj_id
  if branch == None:
    return []
  index = cub.obj_bus
  endCubs = []
  endCubs.extend(getCubicle(branch, index, 0))
  endCubs.extend(getCubicle(branch, index, 1))
  endCubs.extend(getCubicle(branch, index, 2))
  endCubs.extend(getCubicle(branch, index, 3))
  return endCubs

import powerfactory as pf
app = pf.GetApplication()
selection = app.GetDiagramSelection()
if len(selection) != 1:
  app.PrintError("Only the selection of a single terminal is allowed in the single line diagram.")
  exit()
elif selection[0].GetClassName() != "ElmTerm":
  app.PrintError("Only the selection of a single terminal is allowed in the single line diagram.")
  exit()
else:
  firstTerm = selection[0]
  app.PrintInfo("All directly connected termals on the same voltage level are searched for %s" %(firstTerm))

  
foundTerms = [firstTerm]
nextTerms = [firstTerm]

while True:
  if nextTerms == []:
    break
  endCubs = []
  for nextTerm in nextTerms:
    startCubs = [cub for cub in nextTerm.GetContents("*.StaCubic")]    
    for cub in startCubs:
      endCubs.extend(getNextCubs(cub))
  nextTerms = []
  for cub in endCubs:
    term = cub.cterm
    if term == None:
      continue
    else:
      if term not in foundTerms:
        if term.uknom <= firstTerm.uknom*1.1 and term.uknom >= firstTerm.uknom*0.9:
          foundTerms.append(term)
          nextTerms.append(term)
      else:
        continue

app.PrintInfo("The following terminals have been found:")
for term in foundTerms:
  if term.iUsage == 0:
    app.PrintPlain("%s: %.2f kV" %(term, term.uknom))